package ch.epfl.ppo.collections;

import java.util.Iterator;

public final class LinkedList<E> implements List<E> {
    private int size;
    private final Node<E> head;

    public LinkedList() {
        Node<E> head = new Node<>(null);
        head.succ = head.pred = head;

        this.size = 0;
        this.head = head;
    }

    @Override
    public boolean isEmpty() {
        return size == 0;
    }

    @Override
    public int size() {
        return size;
    }

    @Override
    public void add(E newElem) {
        Node<E> newNode = new Node<>(newElem);
        newNode.pred = head.pred;
        newNode.succ = head;
        newNode.pred.succ = newNode.succ.pred = newNode;
        size += 1;
    }

    @Override
    public void remove(int i) {
        checkIndex(i);
        Node<E> nodeToRemove = nodeAtIndex(i);
        nodeToRemove.pred.succ = nodeToRemove.succ;
        nodeToRemove.succ.pred = nodeToRemove.pred;
        size -= 1;
    }

    @Override
    public E get(int i) {
        checkIndex(i);
        return nodeAtIndex(i).value;
    }

    @Override
    public void set(int i, E newElem) {
        // TODO Auto-generated method stub

    }

    @Override
    public Iterator<E> iterator() {
        // TODO Auto-generated method stub
        return null;
    }

    private void checkIndex(int i) {
        if (! (0 <= i && i < size))
            throw new IndexOutOfBoundsException("index out of bounds: " + i);
    }

    private Node<E> nodeAtIndex(int i) {
        Node<E> n = head.succ;
        for (int j = 0; j < i; ++j)
            n = n.succ;
        return n;
    }

    private static class Node<E> {
        public Node<E> succ, pred;
        public E value;

        public Node(E value) {
            this.succ = null;
            this.pred = null;
            this.value = value;
        }
    }
}
